var Client = {
    browser: {
        versions: function () {
            let u = navigator.userAgent,
                app = navigator.appVersion;
            return {
                appflag: u.indexOf('yuanquapp-flutter') > -1, //UA模块 每个项目都需要改
                isFlutter: u.indexOf('app-flutter') > -1, //flutter框架
                trident: u.indexOf('Trident') > -1, //IE内核
                presto: u.indexOf('Presto') > -1, //opera内核
                webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
                gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1, //火狐内核
                mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
                ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
                android: u.indexOf('Android') > -1 || u.indexOf('Adr') > -1, //android终端
                iPhone: u.indexOf('iPhone') > -1, //是否为iPhone或者QQHD浏览器
                iPad: u.indexOf('iPad') > -1, //是否iPad
                webApp: u.indexOf('Safari') == -1, //是否web应该程序，没有头部与底部
                weixin: u.indexOf('MicroMessenger') > -1, //是否微信 （2015-01-22新增）
                qq: u.match(/\sQQ/i) == " qq" //是否QQ
            };
        }(),
        language: (navigator.browserLanguage || navigator.language).toLowerCase()
    },
    /***********************************************原生js***************************************************** */
    
    
    /***************
     * 原生ios调用js方法  在全局window上挂载相应的方法即可
     * 
     * 
     ** */



    /*****
     * js调用原生原生ios
     * js调用原生安卓
     * getUserInfoWithOutLogin  是前端与客户端 协商好调用的方法
     */
    getUserInfoPrimordial: function () {
        let self = this;
        let isApp = self.browser.versions.appflag;
        let isIos = self.browser.versions.ios;
        let isAndroid = self.browser.versions.android;
        if (isApp) {
            if (isIos) {
                try {
                    function getNativeDataFunction(functionName, parm = {}) {
                        let payload = {
                            "type": "JSbridge",
                            "functionName": functionName,
                            "arguments": parm
                        };
                        return prompt(JSON.stringify(payload));
                    }
                    return JSON.parse(getNativeDataFunction("getUserInfoWithOutLogin"));
                } catch (e) {
                    console.log('needMethod:');
                }
            } else if (isAndroid) {
                try {
                    return JSON.parse(H5Listener.getUserInfoWithOutLogin());
                } catch (e) {
                    console.log('needMethod:');
                }
            }
        } else {
            return {
                uid: -1,
                device: '',
                nickname: '',
            };
        }
    },
    closeH5Primordial: function () {
        let self = this;
        let isApp = self.browser.versions.appflag;
        let isIos = self.browser.versions.ios;
        let isAndroid = self.browser.versions.android;
        let isFlutter = self.browser.versions.isFlutter;
        if (isApp) {
            if (isFlutter) {
                if (window.flutter_inappwebview.callHandler) {
                    console.log('call handler getuserinfo');
                    window.flutter_inappwebview.callHandler('closeH5', '_closeH5');
                } else {
                    console.log('call handler getuserinfo');
                    window.flutter_inappwebview._callHandler('closeH5', setTimeout(function () { }), JSON.stringify(['_closeH5']));
                }
            } else {
                if (isIos) {
                    try {
                        function getNativeDataFunction(functionName, parm = {}) {
                            let payload = {
                                "type": "JSbridge",
                                "functionName": functionName,
                                "arguments": parm
                            };
                            return prompt(JSON.stringify(payload));
                        }
                        return JSON.parse(getNativeDataFunction("closeH5"));
                    } catch (e) {
                        console.log('needMethod:');
                    }
                } else if (isAndroid) {
                    try {
                        return JSON.parse(H5Listener.closeH5());
                    } catch (e) {
                        console.log('needMethod:');
                    }
                }
            }
        }
    },
    // 需要测试对接
    // makeParamPrimordial: function (data) {
    //     let self = this;
    //     let isApp = self.browser.versions.appflag;
    //     let isIos = self.browser.versions.ios;
    //     let isAndroid = self.browser.versions.android;
    //     let isFlutter = self.browser.versions.isFlutter;
    //     let newData = {};
    //     Object.assign(newData,data)
    //     if (isApp) {
    //         newData['timestamp'] = self.makeTimeStamp();
    //         newData['nonce'] = self.randStr();
    //         let sign = '';
    //         let queryStr = self.makeStr(newData);
    //         if (isIos) {
    //             try {
    //                 function getNativeDataFunction(functionName, parm = {}) {
    //                     let payload = {
    //                         "type": "JSbridge",
    //                         "functionName": functionName,
    //                         "arguments": parm
    //                     };
    //                     return prompt(JSON.stringify(payload));
    //                 }
    //                 sign = getNativeDataFunction("getParamSign", {
    //                     queryStr: queryStr
    //                 });
    //             } catch (e) {
    //                 console.log('needMethod:');
    //             }
    //         } else if (isAndroid) {
    //             try {
    //                 sign = H5Listener.getParamSign(queryStr);
    //             } catch (e) {
    //                 console.log('needMethod:');
    //             }
    //         } else if (isFlutter) {

    //         }
    //         if (sign) {
    //             newData['sign'] = sign;
    //         }
    //         return newData;
    //     } else {
    //         return newData;
    //     }
    // },
    /*************************************************webview 老版本******************************************************** */
    // webview 老版本  例如平顶山商城
    oldFlutterUserInfo: function (callback) {
        let self = this;
        let isFlutter = self.browser.versions.isFlutter;
        if (isFlutter) {
            window.userInfoCallback = function userInfoCallback(param) {
                callback(JSON.parse(param));
            };
            getUserInfo.postMessage('userInfo');
        } else {
            let userInfo = '{ "uid": "-1", "device": ""}';
            callback(JSON.parse(userInfo));
        }
    },
    oldFlutterCloseHtmlPage: function () {
        let self = this;
        let isFlutter = self.browser.versions.isFlutter;
        if (isFlutter) {
            closeCurrentPage.postMessage('userInfo');
            console.log('我被调用了')
        } else {
            console.log('我没有关闭啊')
        }
    },
    // 需对接
    // oldFlutterMakeParam: function (data, callback) {
    //     let self = this;
    //     let newData = {};
    //     Object.assign(newData,data)
    //     let isFlutter = self.browser.versions.isFlutter;
    //     if (isFlutter) {
    //         newData['timestamp'] = self.makeTimeStamp();
    //         newData['nonce'] = self.randStr();
    //         let queryStr = self.makeStr(newData);
    //         window.getSignCallback = function getSignCallback(sign) {
    //             newData['sign'] = sign;
    //             callback(newData);
    //         };
    //         getSign.postMessage(queryStr);
    //     } else {
    //         callback(newData);
    //     }
    // },
    /********************************************************************************************************************** */



    /**
     *  传递回调函数给flutter  通过回调的方式 将用户信息通过JSON传递回来
     * {
     *    "uid": Global.userId,
     *    "device": Global.deviceInfo,
     *    'nickName': Global.nickname
     *  };
     * @param {*} callback 
     */
    // webview 新版本
    // 调用的时候callback 需要挂在到window对象上
    FlutterNewUserInfo: function (callback) { 
        let self = this;
        let isFlutter = self.browser.versions.isFlutter;
        console.log('isFlutter: ', isFlutter);
        if (isFlutter) {
            window.addEventListener("flutterInAppWebViewPlatformReady", function (event) {
                if (window.flutter_inappwebview.callHandler) {
                    console.log('call handler getuserinfo');
                    window.flutter_inappwebview.callHandler('getUserInfo', callback);
                } else {
                    console.log('call handler getuserinfo');
                    window.flutter_inappwebview._callHandler('getUserInfo', setTimeout(function () { }), JSON.stringify([callback]));
                }
            });
        } else {
            let Info = '{ "uid": "-1", "device": "测试设置" }';
            callback(Info);
        }
    },

    //跳登录
    jumpToLogin: function () {
        let self = this;
        let isApp = self.browser.versions.appflag;
        let isIos = self.browser.versions.ios;
        let isAndroid = self.browser.versions.android;
        let isfullter = self.browser.versions.isFlutter;
        if (isApp) {
            if (isfullter) {
                if (window.flutter_inappwebview.callHandler) {
                    console.log('call handler tologin');
                    window.flutter_inappwebview.callHandler('jumpToLogin', '_login');
                } else {
                    console.log('call handler tologin');
                    window.flutter_inappwebview._callHandler('jumpToLogin', setTimeout(function () { }), JSON.stringify(['_login']));
                }
            } else { //原生
                if (isIos) {
                    window.webkit.messageHandlers.getUserInfo.postMessage('');
                } else if (isAndroid) {
                    H5Listener.getUserInfo();
                }
            }
        }
    },
    /*************************************************************公共函数库********************************************************************* */
    //生成签名前的字符串
    // makeStr: function (data) {
    //     let self = this;
    //     let keys = [];
    //     let newStr = '';
    //     $.each(data, function (i, t) {
    //         keys.push(i);
    //     })
    //     keys.sort();
    //     $.each(keys, function (i, t) {
    //         newStr += t + '=' + data[t];
    //     });
    //     return newStr;
    // },
    // //生成随机字符串
    // randStr: function () {
    //     return parseInt(Math.random() * (999999 - 1 + 1) + 1);
    // },
    // //生成秒级时间戳
    // makeTimeStamp: function (date) {
    //     let D = date ? date : new Date();
    //     return parseInt(D.getTime() / 1000);
    // },
};